backend/controllers/AddressController.php
<?php

namespace backend\controllers;

use Yii;
use backend\models\Address;
use backend\models\SearchAddress;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\helpers\ArrayHelper;
use yii\helpers\Html;


/**
 * AddressController implements the CRUD actions for Address model.
 */
class AddressController extends Controller
{
    // public function behaviors()
    // {
    //     return [
    //         'verbs' => [
    //             'class' => VerbFilter::className(),
    //             'actions' => [
    //                 'delete' => ['post'],
    //             ],
    //         ],
    //     ];
    // }

    /**
     * Lists all Address models.
     * @return mixed
     */
    public function actionIndex($parent_id = 0, $type = 1)
    {
        $searchModel = new SearchAddress();
        $params = Yii::$app->request->queryParams;

		$params['SearchAddress']['parent_id'] = $parent_id;
		
        $dataProvider = $searchModel->search($params);
        // $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
		$current = SearchAddress::find()->where(['id'=>$parent_id])->one();

        if(empty($type))
            $type = 1;
        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
            'type' => $type,
            'parents' => SearchAddress::parents($parent_id),
            'parent_id' => $parent_id,
            'current' => $current,			
            // 'name' => $name,
        ]);
    }

    /**
     * Displays a single Address model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Address model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate($parent_id = 0, $type = 0/**/)
    {
        $temp = SearchAddress::find()->where(['id' => $parent_id])->one();
        $id = $temp['id'];
        $dependency_id = $temp['dependency_id'];
        $name = $temp['name'];
        $type = $temp['type'];

        $model = new Address();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('create', [
                'model' => $model,
                'parent_id' => $id,
                'type' => $type+1,
            ]);
        }
    }

    /**
     * Updates an existing Address model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $temp = SearchAddress::find()->where(['id' => $id])->one();
        $type = $temp['type'];
        $parent_id = $temp['parent_id'];
        $dependency_id = $temp['dependency_id'];
        $name = $temp['name'];


        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('update', [
                'model' => $model,
                'parent_id' => $parent_id,
                'type' => $type,
            ]);
        }
    }

    /**
     * Deletes an existing Address model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        if(SearchAddress::canDelete($id)){
        $this->findModel($id)->delete();
        }

        return $this->redirect(['index']);
    }

    /**
     * Finds the Address model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Address the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Address::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
    public function actionList($id = 0/**/)
    {
        $temp = SearchAddress::find()->where(['parent_id' => $id])->all();
        $temp = ArrayHelper::map($temp, 'id', 'name');
        $result =  Html::dropDownList('my-select', NULL, $temp, $options = []);
        return $result;
    }

    public function getFullPath($id = 0 /**/){
        $temp = SearchAddress::parents($id);
        $result = "";
        $result = implode(array_reverse(ArrayHelper::map($temp, 'id', 'name')), " ");
        return $result;

    }
    public function showName($id = 0){
        $result = "";
        $result = SearchAddress::find()->where(['id' => $id])->one()['name'];
        return $result;

    }
}

backend/controllers/RequestController.php
<?php

namespace backend\controllers;

use app\models\Address;
use app\models\CallRequest;
use backend\models\SearchAddress;
use Yii;
use yii\filters\AccessControl;
use yii\filters\VerbFilter;
use yii\helpers\ArrayHelper;
use yii\helpers\Html;
use yii\web\Controller;
use yii\web\NotFoundHttpException;


/**
 * RequestController implements the CRUD actions for CallRequest model.
 */
class RequestController extends Controller
{
    public function init()
    {		
		//$this->bottstrap_css = true;
		Yii::$app->language = 'ru-RU';
	}
	
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['update'],
                        'allow' => true,
						'roles' => ['request_edit']
                    ],
                    [
                        'actions' => ['done'],
                        'allow' => true,
						'roles' => ['request_done']
                    ],
                    [
                        'actions' => ['index', 'view'],
                        'allow' => true,
						'roles' => ['request_view']
                    ],
                    [
                        'actions' => ['create'],
                        'allow' => true,
						'roles' => ['request_create']
                    ],
                    [
                        'actions' => ['getaddrinp'],
                        'allow' => true,
						//'roles' => ['request_create']
                    ],
                    [
                        'actions' => ['getaddrinp2'],
                        'allow' => true,
						//'roles' => ['request_create']
                    ],
                    [
                        'actions' => ['view-posible-dependency'],
                        'allow' => true,
						//'roles' => ['request_create']
                    ],
                    [
                        'actions' => ['get-sub-crash'],
                        'allow' => true,
						//'roles' => ['request_create']
                    ],
					
                ],
            ],		
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['post'],
                ],
            ],
        ];
    }

    /**
     * Lists all CallRequest models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new RequestSearch();
		$queryParams = Yii::$app->request->queryParams;
		if (!array_key_exists('sort', $queryParams))
		{
			return $this->redirect(['index','sort'=>'-id']);
		}

        $dataProvider = $searchModel->search($queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

	public function actionGetSubCrash($id)
    {
		$a_sub_crash = CallRequest::find()->where(['crash_id'=>$id]);
		$dataProvider = new \yii\data\ActiveDataProvider([
			'query' => $a_sub_crash,
		]);


		return $this->renderPartial('sub_crash_tr', [
            'searchModel' => null,
            'dataProvider' => $dataProvider,
			'only_rec' => true,
        ]);
    }

    /**
     * Displays a single CallRequest model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->renderPartial('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new CallRequest model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */

	public function actionCreate()
	{
        $model = new \app\models\CallRequest();
		$model->scenario = 'create';
		
		if(Yii::$app->request->post()==array())
		{
			return $this->renderPartial('m_create', [
				'model' => $model,
				'title' => 'Create Call Request',
			]);
		}
		
		// сохранение
        if($model->load(Yii::$app->request->post()) && $model->validate() && $model->save() /*&& $model->contact(Yii::$app->params['adminEmail'])/**/) 
		{
			$responsible_user = ArrayHelper::getValue(Yii::$app->request->post(), 'CallRequest.responsible_user', array());
			if (!is_array($responsible_user)) $responsible_user = [$responsible_user];
			$model->setResponsibleUsers($responsible_user);
			
            $result=[
				'result'=>true,
				'msg'=>'Сохранено'// . print_r(Yii::$app->request->post('CallRequest')['responsible_user'],1)
			];
            return json_encode($result);
        }
		// если сохранение не удалось или не прошла проверка
        else
        {
            $result=[
				'result'=>false,
				'content'=> $this->renderPartial(
					'm_create', [
						'model' => $model,
						'title' => 'Create Call Request',
					]
				),
				'msg'=>'Ошибка'
			];
            return json_encode($result);			
        }
    }

    /**
     * Updates an existing CallRequest model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
		$model = $this->findModel($id);
		if(Yii::$app->request->post()==array())
		{
			return $this->renderPartial('m_create', [
				'model' => $model,
				'title' => 'Update Call Request',
			]);
		}
		
		$model->scenario = 'update';
		// сохранение
        if($model->load(Yii::$app->request->post()) && $model->validate() && $model->canEdit() && $model->save()) 
		{
            $result=[
				'result'=>true,
				'msg'=>'Сохранено'// . print_r(Yii::$app->request->post('CallRequest')['responsible_user'],1)
			];
            return json_encode($result);
        }
		// если сохранение не удалось или не прошла проверка
        else
        {
            $result=[
				'result'=>false,
				'content'=> $this->renderPartial(
					'm_create', [
						'model' => $model,
						'title' => 'Update Call Request',
					]
				),
				'msg'=>'Ошибка' //. print_r($rr,1)
			];
            return json_encode($result);
        }
    }

    public function actionViewPosibleDependency($id)
    {
		$a_dependency = CallRequest::getPosibleDependencyAddress($id);
		foreach ($a_dependency as &$rec)
		{
			$rec->text = "<div class = \"col-sm-9\"><div>{$rec->address}</div><div>{$rec->comment}</div></div>";
		}
		unset($rec);
		$a_address_history = [];
		
		$a_address_history = CallRequest::find($id)->where(['address_id'=>$id])->all();
		
		return $this->renderPartial('m_posible_dependency', [
			'a_dependency' => $a_dependency,
			'a_address_history' => $a_address_history,
			'title' => 'Зависимость от аварии',
		]);
	}
	
    public function actionDone($id)
    {
		$model = $this->findModel($id);
		if(Yii::$app->request->post()==array())
		{
			return $this->renderPartial('done', [
				'model' => $this->findModel($id),
			]);
		}
		else
		if($model->canEdit())
		{
			$post = Yii::$app->request->post('CallRequest');
			$model->comment_done = ArrayHelper::getValue(Yii::$app->request->post(), 'CallRequest.comment_done', null);
			$model->comment_done = ArrayHelper::getValue(Yii::$app->request->post(), 'CallRequest.comment_done', null);
			$model->time_performed = ArrayHelper::getValue(Yii::$app->request->post(), 'CallRequest.time_performed', null);
			$responsible_user = ArrayHelper::getValue(Yii::$app->request->post(), 'CallRequest.responsible_user', array());
			if (!is_array($responsible_user))
				$responsible_user = [$responsible_user];
			if (implode($responsible_user,'') == '')
				$responsible_user[] = Yii::$app->user->getId();
			$model->scenario = 'done';
			if($model->validate() && $model->save())
			{
				if(Yii::$app->user->can('operator')){
					$model->setResponsibleUsers($responsible_user);
				}
				else
				{
					$model->setResponsibleUser(Yii::$app->user->getId());
				}
				$result=[
					'result'=>true,
					'content'=> $this->renderPartial(
						'done', ['model' => $model]
					),
					'msg'=>'Выполнено'
				];
				return json_encode($result);
			}
			else
			{
				$result=[
					'result'=>!true,
					'content'=> $this->renderPartial(
						'done', ['model' => $model]
					),
					'msg'=>'Ошибка ' . implode($model->getErrors('closed'), ', ')
				];
				return json_encode($result);		
			}
		}
    }

    /**
     * Deletes an existing CallRequest model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the CallRequest model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return CallRequest the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = CallRequest::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
	
    public function actionGetaddrinp($id = 0)
    {
		$uu = Yii::$app->request->post();
        $temp = SearchAddress::find()->where(['parent_id' => $id])->orderBy('name')->all();
		array_unshift($temp, ['id'=>0, 'name'=>Yii::t('app', '-select-')]);
        $temp = ArrayHelper::map($temp, 'id', 'name');
        $result =  Html::dropDownList('my-select', NULL, $temp, $options = []); /**/
        return $result;
    }

    public function renderAddrinp($id = 0)
    {
        $temp = SearchAddress::find()->where(['parent_id' => $id])->all();
		array_unshift($temp, ['id'=>0, 'name'=>Yii::t('app', '-select-')]);
        $temp = ArrayHelper::map($temp, 'id', 'name');
		$result =  Html::dropDownList('my-select', NULL, $temp, $options = []);
	}
	
    public function actionGetaddrinp2($id = 0)
    {

backend/views/address/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use backend\models\Address;
use backend\models\SearchAddress;
use yii\helpers\Url;

/* @var $this yii\web\View */
/* @var $model backend\models\Address */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="address-form">
    
    <?php if (!isset($parent_id)){
        $parent_id = 0;
        } ?>
    <?php $form = ActiveForm::begin(); ?>

    <?//= $form->field($model, 'parent_id')->textInput() ?>
    <?= $form->field($model, 'parent_id')->hiddenInput(['value' => $parent_id])->label(false) ?>
    <?= $form->field($model, 'type')->hiddenInput(['value' => $type])->label(false) ?>

    <?= $form->field($model, 'name')->textInput(['maxlength' => true]) ?>

    
    
    <?php if($type>2){ ?>
        <?= $form->field($model, 'dependency_id')->hiddenInput()->label(Yii::t('app', 'Dependency ID')) ?>
        <?php $this->registerJsFile(
            '@web/js/drop_down.js',
            ['depends' => 'yii\web\YiiAsset' ]
            );
       ?>
    <?= Html::hiddenInput('path_2', Url::toRoute('request/getaddrinp'), ['id' => 'j_path_addr_inp']) ?>
    <div class="row j_address">
        <div class="col-md-2 j_col_addr">
            <?=$form->field($model, 'city')->listBox(ArrayHelper::map(Address::getChildrens(0, true), 'id', 'name'), ['maxlength' => 255, 'size'=>'1'])?>
        </div>
        <div class="col-md-4 j_col_addr">
            <?=$form->field($model, 'street')->listBox(ArrayHelper::map(Address::getChildrens($model->city, true), 'id', 'name'), ['maxlength' => 255, 'size'=>'1'])?>
        </div>
        <div class="col-md-2 j_col_addr">
            <?=$form->field($model, 'house')->listBox(ArrayHelper::map(Address::getChildrens($model->street, true), 'id', 'name'), ['maxlength' => 255, 'size'=>'1'])?>
        </div>
    </div>
    <?php } else { ?>
         <?= $form->field($model, 'dependency_id')->hiddenInput()->label(false) ?>
<?php } ?>

    <div class="form-group">
        <?= Html::submitButton($model->isNewRecord ? Yii::t('app', 'Create') : Yii::t('app', 'Update'), ['class' => $model->isNewRecord ? 'btn btn-success' : 'btn btn-primary']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

backend/views/address/_search.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model backend\models\SearchAddress */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="address-search">

    <?php $form = ActiveForm::begin([
        'action' => ['index'],
        'method' => 'get',
    ]); ?>

    <?= $form->field($model, 'id') ?>

    <?= $form->field($model, 'parent_id') ?>

    <?= $form->field($model, 'type') ?>

    <?= $form->field($model, 'name') ?>

    <?= $form->field($model, 'dependency_id') ?>

    <div class="form-group">
        <?= Html::submitButton(Yii::t('app', 'Search'), ['class' => 'btn btn-primary']) ?>
        <?= Html::resetButton(Yii::t('app', 'Reset'), ['class' => 'btn btn-default']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

backend/views/address/create.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model backend\models\Address */

$Addresses = ['', 'City', 'Street', 'House'];
// $this->title = Yii::t('app', 'Create Address');
$this->title = Yii::t('app', 'Create '.$Addresses[$type]);

$this->params['breadcrumbs'][] = ['label' => Yii::t('app', $Addresses[$type]), 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Addresses'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="address-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
        'type' => $type,
        'parent_id' => $parent_id,
    ]) ?>

</div>

backend/views/address/index.php
<?php

use yii\helpers\Html;
use yii\helpers\Url;
use yii\grid\GridView;
use backend\models\SearchAddress;
use backend\controllers\AddressController;


/* @var $this yii\web\View */
/* @var $searchModel backend\models\SearchAddress */
/* @var $dataProvider yii\data\ActiveDataProvider */
/*if(empty($type))
	$type = 1;/**/
$word = ['', 'City', 'Street', 'House'];
$words = ['', 'Cities', 'Streets', 'Houses'];
$bwords = ['', 'Create City', 'Create Street', 'Create House'];
$this->title = Yii::t('app', $words[$type]);
//$this->title = Yii::t('app', 'Addresses');
//$this->title = Yii::t('app', 'Addresses');
$this->params['breadcrumbs'] = [];
if(!empty($current['name'])) $this->params['breadcrumbs'][] = $current['name'];
?>
<? //= Html::a($current['name'], ['index', 'parent_id' => $parent_id/*, 'type' => $type,/**/], ['class' => 'btn btn-success']) /**/?>
<?
$this->params['breadcrumbs'][] = Yii::t('app', $words[$type]) ;
//$this->params['breadcrumbs'][] = $this->title;

?>
<div class="address-index">
    <h1><?= Html::encode($this->title) ?></h1>
    <p>
        <?= Html::a(Yii::t('app', $bwords[$type]), ['create', 'parent_id' => $parent_id/*, 'type' => $type,/**/], ['class' => 'btn btn-success']) /**/?>
    </p>
        <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'id',
            // 'name',
            [
                'attribute' => 'name',
                'value' => function ($data) {
                    if($data->type<3){
                    return Html::a(Html::encode($data->name), Url::to(['index', 'parent_id' => $data->id, 'type' => $data->type+1]));}
                    else {return Html::encode($data->name);}
                },
                'format' => 'raw',
            ],
            //'parent_id',
            //'dependency_id',
            [
                'attribute' => 'dependency_id',
                'value' => function ($data) {
                    return Html::a(Html::encode(backend\controllers\AddressController::getFullPath($data->dependency_id)), Url::to(['address/view', 'id' => $data->dependency_id,]));
                },
                'format' => 'raw',
            ],

            [
                'class' => 'app\widgets\AddressActionColumn',
                'template' => '<p style="white-space: nowrap;">{update} {view} {delete}</p>',
                'parent_id' => $parent_id,
                'type' => $type,
                // 'name' => $name,
                'buttons' => [
                    'update' => function($url, $model) {
                        $url = \yii\helpers\Url::toRoute(['/address/update', 'id' => $model->id/**/]);
                        return Html::a('<span class="glyphicon glyphicon-pencil"></span>', $url, [
                            'title' => 'Редактирование',
                            'data-pjax' => '0',             // отключение стандартного обработчика pjax. Он все портит:)
                            /*'class' => 'j_edit_request' /**/
                        ]);
                    },
                    'view' => function($url, $model) {
                        $url = \yii\helpers\Url::toRoute(['/address/view', 'id' => $model->id]);
                        return Html::a('<span class="glyphicon glyphicon-eye-open"></span>', $url, [
                            'title' => 'Просмотр',
                            'data-pjax' => '0',
                            /*'class' => 'j_view_request'/**/
                        ]);
                    },
                    'delete' => function($url, $model) {
                        $url = \yii\helpers\Url::toRoute(['/address/delete', 'id' => $model->id]);
                        if(SearchAddress::canDelete($model->id)){
                        return Html::a('<span class="glyphicon glyphicon-trash"></span>', $url, [
                            'title' => 'Удалить',
                            'data-pjax' => '0',
                            /*'class' => 'j_done_request'/**/
                            'data' => [
                                'confirm' => Yii::t('app', 'Are you sure you want to delete this item?'),
                                'method' => 'post',
                            ],
                        ]);
                        }
                        else return;

                    },
                ],
                'contentOptions' => array('class' => 'col-xs-1', 'align'=>'center'),
            ]
        ],
    ]); ?>
</div>

backend/views/address/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model backend\models\Address */

$this->title = Yii::t('app', 'Update {modelClass}: ', [
    'modelClass' => 'Address',
]) . ' ' . $model->name;
$Addresses = ['', 'City', 'Street', 'House'];

$this->title = Yii::t('app', 'Update') . ' ' . Yii::t('app', $Addresses[$type]). ' ' . $model->name;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', $Addresses[$type]), 'url' => ['index']];
//$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Addresses'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;

/*$this->params['breadcrumbs'][] = ['label' => $model->name, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = Yii::t('app', 'Update');/**/
?>
<div class="address-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
        'parent_id' => $parent_id,
        'type' => $type,
    ]) ?>

</div>

backend/views/address/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use backend\models\SearchAddress;


/* @var $this yii\web\View */
/* @var $model backend\models\Address */

$this->title = $model->name;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Addresses'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="address-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a(Yii::t('app', 'Update'), ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>

        <?php if(SearchAddress::canDelete($model->id)){ ?>
        <?= Html::a(Yii::t('app', 'Delete'), ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => Yii::t('app', 'Are you sure you want to delete this item?'),
                'method' => 'post',
            ],
        ]) ?>
        <?php } ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'id',
            'parent_id',
            'type',
            'name',
            'dependency_id',
        ],
    ]) ?>

</div>